diff -pruN 0.96.1+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.appdata.xml 0.96.2+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.appdata.xml
--- 0.96.1+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.appdata.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.96.2+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.appdata.xml	2024-06-10 02:20:56.000000000 +0000
@@ -0,0 +1,69 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<component type="desktop-application">
+  <id>net.sourceforge.quakespasm.Quakespasm</id>
+  <name>Quakespasm</name>
+  <developer id="quakespasm.sourceforge.net"><name>Quakespasm contributors</name></developer>
+  <summary>A modern port of the original Quake engine</summary>
+  <metadata_license>CC0-1.0</metadata_license>
+  <project_license>GPL-2.0-only</project_license>
+  <url type="homepage">https://quakespasm.sourceforge.net/</url>
+  <launchable type="desktop-id">net.sourceforge.quakespasm.Quakespasm.desktop</launchable>
+  <description>
+    <p>Quakespasm is a *Nix friendly Quake Engine based on the SDL port of the popular FitzQuake.
+      It includes some new features, important fixes, and aims for portability and 64 bit correctness.</p>
+    <p>Features:</p>
+      <ul>
+        <li>Supports Windows, Mac OS X, Linux, other unices.</li>
+        <li>Well tested on both 32 bit and 64 bit platforms.</li>
+        <li>Well tested on both little endian and big endian platforms.</li>
+        <li>OpenGL improvements. In-game resolution changing.</li>
+        <li>Widescreen FOV (field of view) support and automatic Hor+ FOV scaling.</li>
+        <li>Improved sound support. Support for OGG, MP3, Opus and WAV external music files.</li>
+        <li>Improved game controller support using SDL2.</li>
+        <li>Countless bug fixes, security fixes and other improvements.</li>
+        <li>Support for playing the 'Quake 2021 re-release' content</li>
+      </ul>
+    <p>Quakespasm requires a copy of the Quake game data, at the least in the form of the shareware data file
+      pak0.pak. In order to set this up, open (and if necessary create) the directory
+      <code>~/.var/app/net.sourceforge.quakespasm.Quakespasm/data</code> on your computer and copy the <code>id1</code> directory
+      from a copy of Quake there. Quakespasm will notify you on startup if it cannot find or access the game data.</p>
+  </description>
+  <screenshots>
+    <screenshot type="default">
+      <image type="source">https://a.fsdn.com/con/app/proj/quakespasm/screenshots/ad_1.png/max/max/1</image>
+      <caption>Arcane Dimensions</caption>
+    </screenshot>
+    <screenshot>
+      <image type="source">https://a.fsdn.com/con/app/proj/quakespasm/screenshots/spasm0000.png/max/max/1</image>
+      <caption>Arcane Dimensions</caption>
+    </screenshot>
+    <screenshot>
+      <image type="source">https://a.fsdn.com/con/app/proj/quakespasm/screenshots/253088.jpg/max/max/1</image>
+      <caption>2021 re-release support</caption>
+    </screenshot>
+    <screenshot>
+      <image type="source">https://a.fsdn.com/con/app/proj/quakespasm/screenshots/spasm0000-2173.png/max/max/1</image>
+      <caption>Horde of Zendar</caption>
+    </screenshot>
+    <screenshot>
+      <image type="source">https://a.fsdn.com/con/app/proj/quakespasm/screenshots/ad_2.png/max/max/1</image>
+      <caption>The Crucial Error</caption>
+    </screenshot>
+    <screenshot>
+      <image type="source">https://a.fsdn.com/con/app/proj/quakespasm/screenshots/ad_7.png/max/max/1</image>
+      <caption>Arcane Dimensions secret level</caption>
+    </screenshot>
+  </screenshots>
+  <categories>
+    <category>Game</category>
+  </categories>
+  <releases>
+    <release version="0.96.2" date="2024-06-10"/>
+  </releases>
+  <content_rating type="oars-1.1">
+    <content_attribute id="violence-fantasy">intense</content_attribute>
+    <content_attribute id="violence-bloodshed">intense</content_attribute>
+    <content_attribute id="violence-desecration">moderate</content_attribute>
+  </content_rating>
+  <update_contact>https://sourceforge.net/projects/quakespasm/support</update_contact>
+</component>
diff -pruN 0.96.1+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.desktop 0.96.2+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.desktop
--- 0.96.1+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.desktop	1970-01-01 00:00:00.000000000 +0000
+++ 0.96.2+dfsg-1/Linux/net.sourceforge.quakespasm.Quakespasm.desktop	2023-12-08 00:00:00.000000000 +0000
@@ -0,0 +1,11 @@
+[Desktop Entry]
+Name=Quakespasm
+Comment=A modernised fork of the Quake engine
+Exec=quakespasm
+Icon=net.sourceforge.quakespasm.Quakespasm
+StartupNotify=true
+PrefersNonDefaultGPU=true
+Terminal=false
+Type=Application
+Categories=Game;Shooter;
+Keywords=quake;first;person;shooter;
diff -pruN 0.96.1+dfsg-1/Linux/sgml/Quakespasm.sgml 0.96.2+dfsg-1/Linux/sgml/Quakespasm.sgml
--- 0.96.1+dfsg-1/Linux/sgml/Quakespasm.sgml	2023-09-24 14:03:10.000000000 +0000
+++ 0.96.2+dfsg-1/Linux/sgml/Quakespasm.sgml	2024-06-10 02:20:02.000000000 +0000
@@ -3,10 +3,9 @@
 <title>QuakeSpasm
 <toc>
 
-<em>Page last edited: September 2023.</em>
+<em>Page last edited: June 2024.</em>
 
 <sect>About<p>
-
 QuakeSpasm is a modern cross-platform Quake engine based on FitzQuake.
 </p><p>
 It includes support for 64 bit CPUs and custom music playback, a new
@@ -17,7 +16,6 @@ SDL2 has nicer features, smoother mouse
 but no CD-ROM support.
 
 <sect>Downloads<p>
-
 <itemize>
 <item><url url="http://quakespasm.sourceforge.net/download.htm" name="Project Downloads">
 <item><url url="https://sourceforge.net/p/quakespasm/quakespasm/ci/master/tree/" name="Latest code repository">
@@ -139,6 +137,24 @@ QuakeSpasm 0.94 has support for playing
 
 <sect>Changes<p>
 
+<sect1>Changes in 0.96.2<p>
+<itemize>
+<item> Fix stack buffer overrun Mod_PolyForUnlitSurface: fixes crash when loading lim_daviddg.bsp from Liminal Spaces Jam.
+<item> Fix potential buffer overflow in progs global string functions.
+<item> Fix potential buffer overflow in Mod_LoadAliasFrame()
+<item> Optimize BoxOnPlaneSide()
+<item> Reserve enough space in PF_makestatic() for worst case scenarios.
+<item> Improve handling of huge entities in SV_FindTouchedLeafs()
+<item> Warn about bad maps with only 1 or 2 edges per face (e.g.: mj4m?, alk_dancing, ej3_bizz, rotj_entsoy...)
+<item> Apply FOV gun scaling for r_showtris
+<item> Sliders with visible values in options menu.
+<item> game command now refuses setting a non-existing game directory
+<item> Fix build in C23 mode.
+<item> Minor code cleanups. Updated third party code, e.g. SDL, music codecs, etc.
+<item> Thanks to Andrei Drexler, Alexey Lysiuk, Diordany van Hemert, and Jaime Moreira for patches.
+</itemize>
+</p>
+
 <sect1>Changes in 0.96.1<p>
 <itemize>
 <item> Fix demo recording as client-only after connection to server (was broken by signon changes in 0.96.0. Thanks to Jozsef Szalontai for issue report.)
diff -pruN 0.96.1+dfsg-1/Misc/fix_externaltex.patch 0.96.2+dfsg-1/Misc/fix_externaltex.patch
--- 0.96.1+dfsg-1/Misc/fix_externaltex.patch	2023-09-01 22:20:20.000000000 +0000
+++ 0.96.2+dfsg-1/Misc/fix_externaltex.patch	2024-02-10 15:50:00.000000000 +0000
@@ -4,7 +4,7 @@ diff --git a/Quake/gl_model.c b/Quake/gl
 index 239d361..80948f1 100644
 --- a/Quake/gl_model.c
 +++ b/Quake/gl_model.c
-@@ -39,6 +39,8 @@ static void Mod_Print (void);
+@@ -39,6 +39,8 @@
  static cvar_t	external_ents = {"external_ents", "1", CVAR_ARCHIVE};
  static cvar_t	external_vis = {"external_vis", "1", CVAR_ARCHIVE};
  
@@ -82,7 +82,7 @@ diff --git a/Quake/gl_rmain.c b/Quake/gl
 index 6883161..4a8a745 100644
 --- a/Quake/gl_rmain.c
 +++ b/Quake/gl_rmain.c
-@@ -100,6 +100,8 @@ cvar_t	r_noshadow_list = {"r_noshadow_list", "progs/flame2.mdl,progs/flame.mdl,p
+@@ -100,6 +100,8 @@
  extern cvar_t	r_vfog;
  //johnfitz
  
@@ -92,10 +92,10 @@ index 6883161..4a8a745 100644
  
  cvar_t	r_lavaalpha = {"r_lavaalpha","0",CVAR_NONE};
 diff --git a/Quake/gl_rmisc.c b/Quake/gl_rmisc.c
-index 93791f6..4006c5d 100644
+index 963d55e..e9b251b 100644
 --- a/Quake/gl_rmisc.c
 +++ b/Quake/gl_rmisc.c
-@@ -47,6 +47,7 @@ extern cvar_t r_nolerp_list;
+@@ -47,6 +47,7 @@
  extern cvar_t r_noshadow_list;
  //johnfitz
  extern cvar_t gl_zfix; // QuakeSpasm z-fighting fix
@@ -103,7 +103,7 @@ index 93791f6..4006c5d 100644
  
  extern gltexture_t *playertextures[MAX_SCOREBOARD]; //johnfitz
  
-@@ -231,6 +232,7 @@ void R_Init (void)
+@@ -230,6 +231,7 @@ void R_Init (void)
  	Cvar_SetCallback (&r_lavaalpha, R_SetLavaalpha_f);
  	Cvar_SetCallback (&r_telealpha, R_SetTelealpha_f);
  	Cvar_SetCallback (&r_slimealpha, R_SetSlimealpha_f);
diff -pruN 0.96.1+dfsg-1/Quake/common.c 0.96.2+dfsg-1/Quake/common.c
--- 0.96.1+dfsg-1/Quake/common.c	2023-09-24 14:01:50.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/common.c	2024-06-07 08:50:02.000000000 +0000
@@ -2189,6 +2189,15 @@ static void COM_Game_f (void)
 			}
 		}
 
+		if (Sys_FileType(va("%s/%s", com_basedir, p)) != FS_ENT_DIRECTORY)
+		{
+			if (host_parms->userdir == host_parms->basedir || (Sys_FileType(va("%s/%s", host_parms->userdir, p)) != FS_ENT_DIRECTORY))
+			{
+				Con_Printf ("No such game directory \"%s\"\n", p);
+				return;
+			}
+		}
+
 		if (!q_strcasecmp(p, COM_SkipPath(com_gamedir))) //no change
 		{
 			if (com_searchpaths->path_id > 1) { //current game not id1
diff -pruN 0.96.1+dfsg-1/Quake/console.c 0.96.2+dfsg-1/Quake/console.c
--- 0.96.1+dfsg-1/Quake/console.c	2023-09-25 00:25:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/console.c	2024-06-04 21:30:24.000000000 +0000
@@ -840,7 +840,7 @@ FindCompletion -- stevenaaus
 */
 const char *FindCompletion (const char *partial, filelist_item_t *filelist, int *nummatches_out)
 {
-	static char matched[32];
+	static char matched[40];
 	char *i_matched, *i_name;
 	filelist_item_t	*file;
 	int   init, match, plen;
diff -pruN 0.96.1+dfsg-1/Quake/gl_model.c 0.96.2+dfsg-1/Quake/gl_model.c
--- 0.96.1+dfsg-1/Quake/gl_model.c	2023-08-28 07:01:00.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/gl_model.c	2024-06-10 02:20:02.000000000 +0000
@@ -1150,38 +1150,28 @@ TODO: merge this into BuildSurfaceDispla
 */
 static void Mod_PolyForUnlitSurface (msurface_t *fa)
 {
-	vec3_t		verts[64];
-	int			numverts, i, lindex;
+	const int	numverts = fa->numedges;
+	int		i, lindex;
 	float		*vec;
 	glpoly_t	*poly;
 	float		texscale;
 
 	if (fa->flags & (SURF_DRAWTURB | SURF_DRAWSKY))
-		texscale = (1.0/128.0); //warp animation repeats every 128
+		texscale = (1.0f/128.0f); //warp animation repeats every 128
 	else
-		texscale = (1.0/32.0); //to match r_notexture_mip
+		texscale = (1.0f/32.0f); //to match r_notexture_mip
 
-	// convert edges back to a normal polygon
-	numverts = 0;
-	for (i=0 ; i<fa->numedges ; i++)
-	{
-		lindex = loadmodel->surfedges[fa->firstedge + i];
-
-		if (lindex > 0)
-			vec = loadmodel->vertexes[loadmodel->edges[lindex].v[0]].position;
-		else
-			vec = loadmodel->vertexes[loadmodel->edges[-lindex].v[1]].position;
-		VectorCopy (vec, verts[numverts]);
-		numverts++;
-	}
-
-	//create the poly
 	poly = (glpoly_t *) Hunk_Alloc (sizeof(glpoly_t) + (numverts-4) * VERTEXSIZE*sizeof(float));
 	poly->next = NULL;
 	fa->polys = poly;
 	poly->numverts = numverts;
-	for (i=0, vec=(float *)verts; i<numverts; i++, vec+= 3)
+	for (i=0; i<numverts; i++)
 	{
+		lindex = loadmodel->surfedges[fa->firstedge + i];
+		vec = (lindex > 0) ?
+			loadmodel->vertexes[loadmodel->edges[lindex].v[0]].position :
+			loadmodel->vertexes[loadmodel->edges[-lindex].v[1]].position;
+
 		VectorCopy (vec, poly->verts[i]);
 		poly->verts[i][3] = DotProduct(vec, fa->texinfo->vecs[0]) * texscale;
 		poly->verts[i][4] = DotProduct(vec, fa->texinfo->vecs[1]) * texscale;
@@ -1292,6 +1282,8 @@ static void Mod_LoadFaces (lump_t *l, qb
 		}
 
 		out->flags = 0;
+		if (out->numedges < 3)
+			Con_Warning("surfnum %d: bad numedges %d\n", surfnum, out->numedges);
 
 		if (side)
 			out->flags |= SURF_PLANEBACK;
@@ -2367,7 +2359,7 @@ static void *Mod_LoadAliasFrame (void *
 
 	pdaliasframe = (daliasframe_t *)pin;
 
-	strcpy (frame->name, pdaliasframe->name);
+	q_strlcpy (frame->name, pdaliasframe->name, sizeof (frame->name));
 	frame->firstpose = posenum;
 	frame->numposes = 1;
 
diff -pruN 0.96.1+dfsg-1/Quake/gl_warp.c 0.96.2+dfsg-1/Quake/gl_warp.c
--- 0.96.1+dfsg-1/Quake/gl_warp.c	2023-09-30 11:35:02.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/gl_warp.c	2024-06-07 08:50:02.000000000 +0000
@@ -44,11 +44,11 @@ static const float	turbsin[] = {
 //
 //==============================================================================
 
-msurface_t	*warpface;
+static msurface_t	*warpface;
 
 cvar_t gl_subdivide_size = {"gl_subdivide_size", "128", CVAR_ARCHIVE};
 
-void BoundPoly (int numverts, float *verts, vec3_t mins, vec3_t maxs)
+static void BoundPoly (int numverts, float *verts, vec3_t mins, vec3_t maxs)
 {
 	int		i, j;
 	float	*v;
@@ -66,7 +66,7 @@ void BoundPoly (int numverts, float *ver
 		}
 }
 
-void SubdividePolygon (int numverts, float *verts)
+static void SubdividePolygon (int numverts, float *verts)
 {
 	int		i, j, k;
 	vec3_t	mins, maxs;
@@ -80,7 +80,7 @@ void SubdividePolygon (int numverts, flo
 	float	s, t;
 
 	if (numverts > 60)
-		Sys_Error ("numverts = %i", numverts);
+		Sys_Error ("SubdividePolygon: numverts = %i", numverts);
 
 	BoundPoly (numverts, verts, mins, maxs);
 
@@ -159,6 +159,9 @@ void GL_SubdivideSurface (msurface_t *fa
 	vec3_t	verts[64];
 	int		i;
 
+	if (fa->polys->numverts > 64)
+		Sys_Error ("GL_SubdivideSurface: numverts = %i", fa->polys->numverts);
+
 	warpface = fa;
 
 	//the first poly in the chain is the undivided poly for newwater rendering.
@@ -214,6 +217,9 @@ void DrawWaterPoly (glpoly_t *p)
 R_UpdateWarpTextures -- johnfitz -- each frame, update warping textures
 =============
 */
+#ifdef __WATCOMC__ /* OW1.9 doesn't have floorf() */
+#define floorf(_val)		(float)floor((_val))
+#endif
 void R_UpdateWarpTextures (void)
 {
 	texture_t *tx;
@@ -223,7 +229,7 @@ void R_UpdateWarpTextures (void)
 	if (r_oldwater.value || cl.paused || r_drawflat_cheatsafe || r_lightmap_cheatsafe)
 		return;
 
-	warptess = 128.0/CLAMP (3.0, floor(r_waterquality.value), 64.0);
+	warptess = 128.0f/CLAMP (3.0f, floorf(r_waterquality.value), 64.0f);
 
 	for (i=0; i<cl.worldmodel->numtextures; i++)
 	{
diff -pruN 0.96.1+dfsg-1/Quake/keys.c 0.96.2+dfsg-1/Quake/keys.c
--- 0.96.1+dfsg-1/Quake/keys.c	2023-03-14 07:20:32.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/keys.c	2024-02-10 15:50:24.000000000 +0000
@@ -466,7 +466,13 @@ void Char_Console (int key)
 			workline[MAXCMDLINE - 2] = 0;
 			workline += key_linepos;
 			len = strlen(workline) + 1;
+			#if defined(__GNUC__) && (__GNUC__ > 7)
+			#pragma GCC diagnostic ignored "-Warray-bounds"
+			#endif
 			memmove (workline + 1, workline, len);
+			#if defined(__GNUC__) && (__GNUC__ > 7)
+			#pragma GCC diagnostic pop
+			#endif
 			*workline = key;
 		}
 		else
diff -pruN 0.96.1+dfsg-1/Quake/mathlib.c 0.96.2+dfsg-1/Quake/mathlib.c
--- 0.96.1+dfsg-1/Quake/mathlib.c	2022-03-11 20:55:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/mathlib.c	2024-03-23 11:05:50.000000000 +0000
@@ -111,6 +111,7 @@ Returns 1, 2, or 1 + 2
 int BoxOnPlaneSide (vec3_t emins, vec3_t emaxs, mplane_t *p)
 {
 	float	dist1, dist2;
+	int		xneg, yneg, zneg;
 	int		sides;
 
 #if 0	// this is done by the BOX_ON_PLANE_SIDE macro before calling this
@@ -126,46 +127,19 @@ int BoxOnPlaneSide (vec3_t emins, vec3_t
 	}
 #endif
 
-// general case
-	switch (p->signbits)
-	{
-	case 0:
-		dist1 = p->normal[0]*emaxs[0] + p->normal[1]*emaxs[1] + p->normal[2]*emaxs[2];
-		dist2 = p->normal[0]*emins[0] + p->normal[1]*emins[1] + p->normal[2]*emins[2];
-		break;
-	case 1:
-		dist1 = p->normal[0]*emins[0] + p->normal[1]*emaxs[1] + p->normal[2]*emaxs[2];
-		dist2 = p->normal[0]*emaxs[0] + p->normal[1]*emins[1] + p->normal[2]*emins[2];
-		break;
-	case 2:
-		dist1 = p->normal[0]*emaxs[0] + p->normal[1]*emins[1] + p->normal[2]*emaxs[2];
-		dist2 = p->normal[0]*emins[0] + p->normal[1]*emaxs[1] + p->normal[2]*emins[2];
-		break;
-	case 3:
-		dist1 = p->normal[0]*emins[0] + p->normal[1]*emins[1] + p->normal[2]*emaxs[2];
-		dist2 = p->normal[0]*emaxs[0] + p->normal[1]*emaxs[1] + p->normal[2]*emins[2];
-		break;
-	case 4:
-		dist1 = p->normal[0]*emaxs[0] + p->normal[1]*emaxs[1] + p->normal[2]*emins[2];
-		dist2 = p->normal[0]*emins[0] + p->normal[1]*emins[1] + p->normal[2]*emaxs[2];
-		break;
-	case 5:
-		dist1 = p->normal[0]*emins[0] + p->normal[1]*emaxs[1] + p->normal[2]*emins[2];
-		dist2 = p->normal[0]*emaxs[0] + p->normal[1]*emins[1] + p->normal[2]*emaxs[2];
-		break;
-	case 6:
-		dist1 = p->normal[0]*emaxs[0] + p->normal[1]*emins[1] + p->normal[2]*emins[2];
-		dist2 = p->normal[0]*emins[0] + p->normal[1]*emaxs[1] + p->normal[2]*emaxs[2];
-		break;
-	case 7:
-		dist1 = p->normal[0]*emins[0] + p->normal[1]*emins[1] + p->normal[2]*emins[2];
-		dist2 = p->normal[0]*emaxs[0] + p->normal[1]*emaxs[1] + p->normal[2]*emaxs[2];
-		break;
-	default:
-		dist1 = dist2 = 0;		// shut up compiler
+	xneg = p->signbits & 1;
+	yneg = (p->signbits >> 1) & 1;
+	zneg = (p->signbits >> 2) & 1;
+
+	dist1 = p->normal[0] * (xneg ? emins : emaxs)[0] +
+			p->normal[1] * (yneg ? emins : emaxs)[1] +
+			p->normal[2] * (zneg ? emins : emaxs)[2];
+	dist2 = p->normal[0] * (xneg ? emaxs : emins)[0] +
+			p->normal[1] * (yneg ? emaxs : emins)[1] +
+			p->normal[2] * (zneg ? emaxs : emins)[2];
+
+	if (p->signbits & ~7)
 		Sys_Error ("BoxOnPlaneSide:  Bad signbits");
-		break;
-	}
 
 #if 0
 	int		i;
diff -pruN 0.96.1+dfsg-1/Quake/menu.c 0.96.2+dfsg-1/Quake/menu.c
--- 0.96.1+dfsg-1/Quake/menu.c	2023-09-25 00:25:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/menu.c	2024-06-04 20:50:02.000000000 +0000
@@ -391,7 +391,7 @@ void M_SinglePlayer_Key (int key)
 		{
 		case 0:
 			if (sv.active)
-				if (!SCR_ModalMessage("Are you sure you want to\nstart a new game?\n", 0.0f))
+				if (!SCR_ModalMessage("Are you sure you want to\nstart a new game? (y/n)\n", 0.0f))
 					break;
 			IN_Activate();
 			key_dest = key_game;
@@ -1137,9 +1137,10 @@ void M_AdjustSliders (int dir)
 }
 
 
-void M_DrawSlider (int x, int y, float range)
+void M_DrawSlider (int x, int y, float range, float value, const char *format)
 {
 	int	i;
+	char	buffer[5];
 
 	if (range < 0)
 		range = 0;
@@ -1150,6 +1151,8 @@ void M_DrawSlider (int x, int y, float r
 		M_DrawCharacter (x + i*8, y, 129);
 	M_DrawCharacter (x+i*8, y, 130);
 	M_DrawCharacter (x + (SLIDER_RANGE-1)*8 * range, y, 131);
+	q_snprintf(buffer, 5, format, value);
+	M_Print (x + (SLIDER_RANGE + 1) * 8, y, buffer);
 }
 
 void M_DrawCheckbox (int x, int y, int on)
@@ -1187,42 +1190,42 @@ void M_Options_Draw (void)
 	M_Print (16, 32 + 8*OPT_SCALE,		"                 Scale");
 	l = (vid.width / 320.0) - 1;
 	r = l > 0 ? (scr_conscale.value - 1) / l : 0;
-	M_DrawSlider (220, 32 + 8*OPT_SCALE, r);
+	M_DrawSlider (220, 32 + 8*OPT_SCALE, r, scr_conscale.value, "%.1f");
 
 	// OPT_SCRSIZE:
 	M_Print (16, 32 + 8*OPT_SCRSIZE,	"           Screen size");
 	r = (scr_viewsize.value - 30) / (120 - 30);
-	M_DrawSlider (220, 32 + 8*OPT_SCRSIZE, r);
+	M_DrawSlider (220, 32 + 8*OPT_SCRSIZE, r, scr_viewsize.value, "%.0f");
 
 	// OPT_GAMMA:
 	M_Print (16, 32 + 8*OPT_GAMMA,		"            Brightness");
 	r = (1.0 - vid_gamma.value) / 0.5;
-	M_DrawSlider (220, 32 + 8*OPT_GAMMA, r);
+	M_DrawSlider (220, 32 + 8*OPT_GAMMA, r, vid_gamma.value, "%.2f");
 
 	// OPT_CONTRAST:
 	M_Print (16, 32 + 8*OPT_CONTRAST,	"              Contrast");
 	r = vid_contrast.value - 1.0;
-	M_DrawSlider (220, 32 + 8*OPT_CONTRAST, r);
+	M_DrawSlider (220, 32 + 8*OPT_CONTRAST, r, vid_contrast.value, "%.1f");
 	
 	// OPT_MOUSESPEED:
 	M_Print (16, 32 + 8*OPT_MOUSESPEED,	"           Mouse Speed");
 	r = (sensitivity.value - 1)/10;
-	M_DrawSlider (220, 32 + 8*OPT_MOUSESPEED, r);
+	M_DrawSlider (220, 32 + 8*OPT_MOUSESPEED, r, sensitivity.value, "%.1f");
 
 	// OPT_SBALPHA:
 	M_Print (16, 32 + 8*OPT_SBALPHA,	"       Statusbar alpha");
 	r = (1.0 - scr_sbaralpha.value) ; // scr_sbaralpha range is 1.0 to 0.0
-	M_DrawSlider (220, 32 + 8*OPT_SBALPHA, r);
+	M_DrawSlider (220, 32 + 8*OPT_SBALPHA, r, scr_sbaralpha.value, "%.2f");
 
 	// OPT_SNDVOL:
 	M_Print (16, 32 + 8*OPT_SNDVOL,		"          Sound Volume");
 	r = sfxvolume.value;
-	M_DrawSlider (220, 32 + 8*OPT_SNDVOL, r);
+	M_DrawSlider (220, 32 + 8*OPT_SNDVOL, r, sfxvolume.value, "%.1f");
 
 	// OPT_MUSICVOL:
 	M_Print (16, 32 + 8*OPT_MUSICVOL,	"          Music Volume");
 	r = bgmvolume.value;
-	M_DrawSlider (220, 32 + 8*OPT_MUSICVOL, r);
+	M_DrawSlider (220, 32 + 8*OPT_MUSICVOL, r, bgmvolume.value, "%.1f");
 
 	// OPT_MUSICEXT:
 	M_Print (16, 32 + 8*OPT_MUSICEXT,	"        External Music");
diff -pruN 0.96.1+dfsg-1/Quake/pr_cmds.c 0.96.2+dfsg-1/Quake/pr_cmds.c
--- 0.96.1+dfsg-1/Quake/pr_cmds.c	2023-09-25 00:25:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/pr_cmds.c	2023-12-22 22:24:04.000000000 +0000
@@ -1624,7 +1624,7 @@ static void PF_makestatic (void)
 		}
 	}
 
-	SV_ReserveSignonSpace (33);
+	SV_ReserveSignonSpace (34);
 
 	if (bits)
 	{
diff -pruN 0.96.1+dfsg-1/Quake/pr_edict.c 0.96.2+dfsg-1/Quake/pr_edict.c
--- 0.96.1+dfsg-1/Quake/pr_edict.c	2023-09-24 14:01:50.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/pr_edict.c	2023-12-25 14:23:20.000000000 +0000
@@ -416,6 +416,7 @@ padded to 20 field width
 const char *PR_GlobalString (int ofs)
 {
 	static char	line[512];
+	static const int lastchari = Q_COUNTOF(line) - 2;
 	const char	*s;
 	int		i;
 	ddef_t		*def;
@@ -434,7 +435,11 @@ const char *PR_GlobalString (int ofs)
 	i = strlen(line);
 	for ( ; i < 20; i++)
 		strcat (line, " ");
-	strcat (line, " ");
+
+	if (i < lastchari)
+		strcat (line, " ");
+	else
+		line[lastchari] = ' ';
 
 	return line;
 }
@@ -442,6 +447,7 @@ const char *PR_GlobalString (int ofs)
 const char *PR_GlobalStringNoContents (int ofs)
 {
 	static char	line[512];
+	static const int lastchari = Q_COUNTOF(line) - 2;
 	int		i;
 	ddef_t		*def;
 
@@ -454,7 +460,11 @@ const char *PR_GlobalStringNoContents (i
 	i = strlen(line);
 	for ( ; i < 20; i++)
 		strcat (line, " ");
-	strcat (line, " ");
+
+	if (i < lastchari)
+		strcat (line, " ");
+	else
+		line[lastchari] = ' ';
 
 	return line;
 }
diff -pruN 0.96.1+dfsg-1/Quake/q_stdinc.h 0.96.2+dfsg-1/Quake/q_stdinc.h
--- 0.96.1+dfsg-1/Quake/q_stdinc.h	2023-09-24 14:01:02.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/q_stdinc.h	2024-05-07 20:24:00.000000000 +0000
@@ -26,8 +26,8 @@
  * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
-#ifndef __QSTDINC_H
-#define __QSTDINC_H
+#ifndef QSTDINC_H
+#define QSTDINC_H
 
 #include <sys/types.h>
 #include <stddef.h>
@@ -126,23 +126,23 @@ COMPILE_TIME_ASSERT(enum, sizeof(THE_DUM
 
 typedef unsigned char		byte;
 
-#undef true
-#undef false
-#if defined(__cplusplus)
 /* some structures have qboolean members and the x86 asm code expect
- * those members to be 4 bytes long. therefore, qboolean must be 32
- * bits and it can NOT be binary compatible with the 8 bit C++ bool.  */
+ * those members to be 4 bytes long.  i.e.: qboolean must be 32 bits.  */
 typedef int	qboolean;
-COMPILE_TIME_ASSERT(falsehood, (0 == false));
-COMPILE_TIME_ASSERT(truth, (1  == true));
+#undef true
+#undef false
+#if !defined(__cplusplus)
+#if defined __STDC_VERSION__ && (__STDC_VERSION__ >= 199901L)
+#include <stdbool.h>
 #else
-typedef enum {
+enum {
 	false = 0,
 	true  = 1
-} qboolean;
+};
+#endif
+#endif /* */
 COMPILE_TIME_ASSERT(falsehood, ((1 != 1) == false));
 COMPILE_TIME_ASSERT(truth, ((1 == 1) == true));
-#endif
 COMPILE_TIME_ASSERT(qboolean, sizeof(qboolean) == 4);
 
 /*==========================================================================*/
@@ -244,6 +244,4 @@ typedef ptrdiff_t	ssize_t;
 
 /*==========================================================================*/
 
-
-#endif	/* __QSTDINC_H */
-
+#endif	/* QSTDINC_H */
diff -pruN 0.96.1+dfsg-1/Quake/quakedef.h 0.96.2+dfsg-1/Quake/quakedef.h
--- 0.96.1+dfsg-1/Quake/quakedef.h	2023-09-17 20:21:50.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/quakedef.h	2024-06-04 22:02:10.000000000 +0000
@@ -37,7 +37,7 @@ Foundation, Inc., 59 Temple Place - Suit
 
 #define	FITZQUAKE_VERSION	0.85	//johnfitz
 #define	QUAKESPASM_VERSION	0.96
-#define	QUAKESPASM_VER_PATCH	1	// helper to print a string like 0.94.7
+#define	QUAKESPASM_VER_PATCH	2	// helper to print a string like 0.94.7
 #ifndef	QUAKESPASM_VER_SUFFIX
 #define	QUAKESPASM_VER_SUFFIX		// optional version suffix string literal like "-beta1"
 #endif
diff -pruN 0.96.1+dfsg-1/Quake/r_alias.c 0.96.2+dfsg-1/Quake/r_alias.c
--- 0.96.1+dfsg-1/Quake/r_alias.c	2023-09-30 11:35:02.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/r_alias.c	2024-06-04 15:59:35.000000000 +0000
@@ -981,6 +981,7 @@ void R_DrawAliasModel_ShowTris (entity_t
 {
 	aliashdr_t	*paliashdr;
 	lerpdata_t	lerpdata;
+	float	fovscale = 1.0f;
 
 	if (R_CullModelForEntity(e))
 		return;
@@ -989,10 +990,13 @@ void R_DrawAliasModel_ShowTris (entity_t
 	R_SetupAliasFrame (paliashdr, e->frame, &lerpdata);
 	R_SetupEntityTransform (e, &lerpdata);
 
+	if (e == &cl.viewent && scr_fov.value > 90.f && cl_gun_fovscale.value)
+		fovscale = tan(scr_fov.value * (0.5f * M_PI / 180.f));
+
 	glPushMatrix ();
 	R_RotateForEntity (lerpdata.origin,lerpdata.angles, e->scale);
-	glTranslatef (paliashdr->scale_origin[0], paliashdr->scale_origin[1], paliashdr->scale_origin[2]);
-	glScalef (paliashdr->scale[0], paliashdr->scale[1], paliashdr->scale[2]);
+	glTranslatef (paliashdr->scale_origin[0], paliashdr->scale_origin[1] * fovscale, paliashdr->scale_origin[2] * fovscale);
+	glScalef (paliashdr->scale[0], paliashdr->scale[1] * fovscale, paliashdr->scale[2] * fovscale);
 
 	shading = false;
 	glColor3f(1,1,1);
diff -pruN 0.96.1+dfsg-1/Quake/r_world.c 0.96.2+dfsg-1/Quake/r_world.c
--- 0.96.1+dfsg-1/Quake/r_world.c	2023-09-25 00:25:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/r_world.c	2024-06-10 02:20:02.000000000 +0000
@@ -319,7 +319,7 @@ void R_DrawTextureChains_Glow (qmodel_t
 //
 //==============================================================================
 
-static unsigned int R_NumTriangleIndicesForSurf (msurface_t *s)
+static int R_NumTriangleIndicesForSurf (msurface_t *s)
 {
 	return 3 * (s->numedges - 2);
 }
@@ -384,9 +384,13 @@ using VBOs.
 */
 static void R_BatchSurface (msurface_t *s)
 {
-	int num_surf_indices;
+	int num_surf_indices = R_NumTriangleIndicesForSurf (s);
 
-	num_surf_indices = R_NumTriangleIndicesForSurf (s);
+	if (num_surf_indices <= 0)
+	{
+	//	Con_DWarning ("bad numedges for surface\n");
+		return;
+	}
 
 	if (num_vbo_indices + num_surf_indices > MAX_BATCH_SIZE)
 		R_FlushBatch();
diff -pruN 0.96.1+dfsg-1/Quake/world.c 0.96.2+dfsg-1/Quake/world.c
--- 0.96.1+dfsg-1/Quake/world.c	2017-08-28 02:15:04.000000000 +0000
+++ 0.96.2+dfsg-1/Quake/world.c	2024-03-23 11:05:50.000000000 +0000
@@ -395,13 +395,13 @@ void SV_FindTouchedLeafs (edict_t *ent,
 	if (node->contents == CONTENTS_SOLID)
 		return;
 
+	if (ent->num_leafs == MAX_ENT_LEAFS)
+		return;
+
 // add an efrag if the node is a leaf
 
 	if ( node->contents < 0)
 	{
-		if (ent->num_leafs == MAX_ENT_LEAFS)
-			return;
-
 		leaf = (mleaf_t *)node;
 		leafnum = leaf - sv.worldmodel->leafs - 1;
 
diff -pruN 0.96.1+dfsg-1/Quakespasm.html 0.96.2+dfsg-1/Quakespasm.html
--- 0.96.1+dfsg-1/Quakespasm.html	2023-09-24 14:03:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quakespasm.html	2024-06-10 02:20:02.000000000 +0000
@@ -7,7 +7,7 @@
 <BODY>
 <H1>QuakeSpasm</H1>
 
-<P><EM>Page last edited: September 2023.</EM></P>
+<P><EM>Page last edited: June 2024.</EM></P>
 
 <P>
 <H2><A NAME="toc1">1.</A> <A HREF="Quakespasm.html#s1">About</A></H2>
@@ -30,35 +30,36 @@
 <P>
 <H2><A NAME="toc5">5.</A> <A HREF="Quakespasm.html#s5">Changes</A></H2>
 <UL>
-<LI><A NAME="toc5.1">5.1</A> <A HREF="Quakespasm.html#ss5.1">Changes in 0.96.1</A>
-<LI><A NAME="toc5.2">5.2</A> <A HREF="Quakespasm.html#ss5.2">Changes in 0.96.0</A>
-<LI><A NAME="toc5.3">5.3</A> <A HREF="Quakespasm.html#ss5.3">Changes in 0.95.1</A>
-<LI><A NAME="toc5.4">5.4</A> <A HREF="Quakespasm.html#ss5.4">Changes in 0.95.0</A>
-<LI><A NAME="toc5.5">5.5</A> <A HREF="Quakespasm.html#ss5.5">Changes in 0.94.7</A>
-<LI><A NAME="toc5.6">5.6</A> <A HREF="Quakespasm.html#ss5.6">Changes in 0.94.6</A>
-<LI><A NAME="toc5.7">5.7</A> <A HREF="Quakespasm.html#ss5.7">Changes in 0.94.5</A>
-<LI><A NAME="toc5.8">5.8</A> <A HREF="Quakespasm.html#ss5.8">Changes in 0.94.4</A>
-<LI><A NAME="toc5.9">5.9</A> <A HREF="Quakespasm.html#ss5.9">Changes in 0.94.3</A>
-<LI><A NAME="toc5.10">5.10</A> <A HREF="Quakespasm.html#ss5.10">Changes in 0.94.2</A>
-<LI><A NAME="toc5.11">5.11</A> <A HREF="Quakespasm.html#ss5.11">Changes in 0.94.1</A>
-<LI><A NAME="toc5.12">5.12</A> <A HREF="Quakespasm.html#ss5.12">Changes in 0.94.0</A>
-<LI><A NAME="toc5.13">5.13</A> <A HREF="Quakespasm.html#ss5.13">Changes in 0.93.2</A>
-<LI><A NAME="toc5.14">5.14</A> <A HREF="Quakespasm.html#ss5.14">Changes in 0.93.1</A>
-<LI><A NAME="toc5.15">5.15</A> <A HREF="Quakespasm.html#ss5.15">Changes in 0.93.0</A>
-<LI><A NAME="toc5.16">5.16</A> <A HREF="Quakespasm.html#ss5.16">Changes in 0.92.1</A>
-<LI><A NAME="toc5.17">5.17</A> <A HREF="Quakespasm.html#ss5.17">Changes in 0.92.0</A>
-<LI><A NAME="toc5.18">5.18</A> <A HREF="Quakespasm.html#ss5.18">Changes in 0.91.0</A>
-<LI><A NAME="toc5.19">5.19</A> <A HREF="Quakespasm.html#ss5.19">Changes in 0.90.1</A>
-<LI><A NAME="toc5.20">5.20</A> <A HREF="Quakespasm.html#ss5.20">Changes in 0.90.0</A>
-<LI><A NAME="toc5.21">5.21</A> <A HREF="Quakespasm.html#ss5.21">Changes in 0.85.9</A>
-<LI><A NAME="toc5.22">5.22</A> <A HREF="Quakespasm.html#ss5.22">Changes in 0.85.8</A>
-<LI><A NAME="toc5.23">5.23</A> <A HREF="Quakespasm.html#ss5.23">Changes in 0.85.7</A>
-<LI><A NAME="toc5.24">5.24</A> <A HREF="Quakespasm.html#ss5.24">Changes in 0.85.6</A>
-<LI><A NAME="toc5.25">5.25</A> <A HREF="Quakespasm.html#ss5.25">Changes in 0.85.5</A>
-<LI><A NAME="toc5.26">5.26</A> <A HREF="Quakespasm.html#ss5.26">Changes in 0.85.4</A>
-<LI><A NAME="toc5.27">5.27</A> <A HREF="Quakespasm.html#ss5.27">Changes in 0.85.3</A>
-<LI><A NAME="toc5.28">5.28</A> <A HREF="Quakespasm.html#ss5.28">Changes in 0.85.2</A>
-<LI><A NAME="toc5.29">5.29</A> <A HREF="Quakespasm.html#ss5.29">Changes in 0.85.1</A>
+<LI><A NAME="toc5.1">5.1</A> <A HREF="Quakespasm.html#ss5.1">Changes in 0.96.2</A>
+<LI><A NAME="toc5.2">5.2</A> <A HREF="Quakespasm.html#ss5.2">Changes in 0.96.1</A>
+<LI><A NAME="toc5.3">5.3</A> <A HREF="Quakespasm.html#ss5.3">Changes in 0.96.0</A>
+<LI><A NAME="toc5.4">5.4</A> <A HREF="Quakespasm.html#ss5.4">Changes in 0.95.1</A>
+<LI><A NAME="toc5.5">5.5</A> <A HREF="Quakespasm.html#ss5.5">Changes in 0.95.0</A>
+<LI><A NAME="toc5.6">5.6</A> <A HREF="Quakespasm.html#ss5.6">Changes in 0.94.7</A>
+<LI><A NAME="toc5.7">5.7</A> <A HREF="Quakespasm.html#ss5.7">Changes in 0.94.6</A>
+<LI><A NAME="toc5.8">5.8</A> <A HREF="Quakespasm.html#ss5.8">Changes in 0.94.5</A>
+<LI><A NAME="toc5.9">5.9</A> <A HREF="Quakespasm.html#ss5.9">Changes in 0.94.4</A>
+<LI><A NAME="toc5.10">5.10</A> <A HREF="Quakespasm.html#ss5.10">Changes in 0.94.3</A>
+<LI><A NAME="toc5.11">5.11</A> <A HREF="Quakespasm.html#ss5.11">Changes in 0.94.2</A>
+<LI><A NAME="toc5.12">5.12</A> <A HREF="Quakespasm.html#ss5.12">Changes in 0.94.1</A>
+<LI><A NAME="toc5.13">5.13</A> <A HREF="Quakespasm.html#ss5.13">Changes in 0.94.0</A>
+<LI><A NAME="toc5.14">5.14</A> <A HREF="Quakespasm.html#ss5.14">Changes in 0.93.2</A>
+<LI><A NAME="toc5.15">5.15</A> <A HREF="Quakespasm.html#ss5.15">Changes in 0.93.1</A>
+<LI><A NAME="toc5.16">5.16</A> <A HREF="Quakespasm.html#ss5.16">Changes in 0.93.0</A>
+<LI><A NAME="toc5.17">5.17</A> <A HREF="Quakespasm.html#ss5.17">Changes in 0.92.1</A>
+<LI><A NAME="toc5.18">5.18</A> <A HREF="Quakespasm.html#ss5.18">Changes in 0.92.0</A>
+<LI><A NAME="toc5.19">5.19</A> <A HREF="Quakespasm.html#ss5.19">Changes in 0.91.0</A>
+<LI><A NAME="toc5.20">5.20</A> <A HREF="Quakespasm.html#ss5.20">Changes in 0.90.1</A>
+<LI><A NAME="toc5.21">5.21</A> <A HREF="Quakespasm.html#ss5.21">Changes in 0.90.0</A>
+<LI><A NAME="toc5.22">5.22</A> <A HREF="Quakespasm.html#ss5.22">Changes in 0.85.9</A>
+<LI><A NAME="toc5.23">5.23</A> <A HREF="Quakespasm.html#ss5.23">Changes in 0.85.8</A>
+<LI><A NAME="toc5.24">5.24</A> <A HREF="Quakespasm.html#ss5.24">Changes in 0.85.7</A>
+<LI><A NAME="toc5.25">5.25</A> <A HREF="Quakespasm.html#ss5.25">Changes in 0.85.6</A>
+<LI><A NAME="toc5.26">5.26</A> <A HREF="Quakespasm.html#ss5.26">Changes in 0.85.5</A>
+<LI><A NAME="toc5.27">5.27</A> <A HREF="Quakespasm.html#ss5.27">Changes in 0.85.4</A>
+<LI><A NAME="toc5.28">5.28</A> <A HREF="Quakespasm.html#ss5.28">Changes in 0.85.3</A>
+<LI><A NAME="toc5.29">5.29</A> <A HREF="Quakespasm.html#ss5.29">Changes in 0.85.2</A>
+<LI><A NAME="toc5.30">5.30</A> <A HREF="Quakespasm.html#ss5.30">Changes in 0.85.1</A>
 </UL>
 <P>
 <H2><A NAME="toc6">6.</A> <A HREF="Quakespasm.html#s6">Copyright</A></H2>
@@ -212,7 +213,27 @@ Alternatively, have a look at <B>Makefil
 
 <H2><A NAME="s5">5.</A> <A HREF="#toc5">Changes</A></H2>
 
-<H2><A NAME="ss5.1">5.1</A> <A HREF="#toc5.1">Changes in 0.96.1</A>
+<H2><A NAME="ss5.1">5.1</A> <A HREF="#toc5.1">Changes in 0.96.2</A>
+</H2>
+<P>
+<UL>
+<LI> Fix stack buffer overrun Mod_PolyForUnlitSurface: fixes crash when loading lim_daviddg.bsp from Liminal Spaces Jam.</LI>
+<LI> Fix potential buffer overflow in progs global string functions.</LI>
+<LI> Fix potential buffer overflow in Mod_LoadAliasFrame()</LI>
+<LI> Optimize BoxOnPlaneSide()</LI>
+<LI> Reserve enough space in PF_makestatic() for worst case scenarios.</LI>
+<LI> Improve handling of huge entities in SV_FindTouchedLeafs()</LI>
+<LI> Warn about bad maps with only 1 or 2 edges per face (e.g.: mj4m?, alk_dancing, ej3_bizz, rotj_entsoy...)</LI>
+<LI> Apply FOV gun scaling for r_showtris</LI>
+<LI> Sliders with visible values in options menu.</LI>
+<LI> game command now refuses setting a non-existing game directory</LI>
+<LI> Fix build in C23 mode.</LI>
+<LI> Minor code cleanups. Updated third party code, e.g. SDL, music codecs, etc.</LI>
+<LI> Thanks to Andrei Drexler, Alexey Lysiuk, Diordany van Hemert, and Jaime Moreira for patches.</LI>
+</UL>
+</P>
+
+<H2><A NAME="ss5.2">5.2</A> <A HREF="#toc5.2">Changes in 0.96.1</A>
 </H2>
 <P>
 <UL>
@@ -222,7 +243,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.2">5.2</A> <A HREF="#toc5.2">Changes in 0.96.0</A>
+<H2><A NAME="ss5.3">5.3</A> <A HREF="#toc5.3">Changes in 0.96.0</A>
 </H2>
 <P>
 <UL>
@@ -259,7 +280,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.3">5.3</A> <A HREF="#toc5.3">Changes in 0.95.1</A>
+<H2><A NAME="ss5.4">5.4</A> <A HREF="#toc5.4">Changes in 0.95.1</A>
 </H2>
 <P>
 <UL>
@@ -273,7 +294,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.4">5.4</A> <A HREF="#toc5.4">Changes in 0.95.0</A>
+<H2><A NAME="ss5.5">5.5</A> <A HREF="#toc5.5">Changes in 0.95.0</A>
 </H2>
 <P>
 <UL>
@@ -286,7 +307,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.5">5.5</A> <A HREF="#toc5.5">Changes in 0.94.7</A>
+<H2><A NAME="ss5.6">5.6</A> <A HREF="#toc5.6">Changes in 0.94.7</A>
 </H2>
 <P>
 <UL>
@@ -297,7 +318,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.6">5.6</A> <A HREF="#toc5.6">Changes in 0.94.6</A>
+<H2><A NAME="ss5.7">5.7</A> <A HREF="#toc5.7">Changes in 0.94.6</A>
 </H2>
 <P>
 <UL>
@@ -310,7 +331,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.7">5.7</A> <A HREF="#toc5.7">Changes in 0.94.5</A>
+<H2><A NAME="ss5.8">5.8</A> <A HREF="#toc5.8">Changes in 0.94.5</A>
 </H2>
 <P>
 <UL>
@@ -323,7 +344,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.8">5.8</A> <A HREF="#toc5.8">Changes in 0.94.4</A>
+<H2><A NAME="ss5.9">5.9</A> <A HREF="#toc5.9">Changes in 0.94.4</A>
 </H2>
 <P>
 <UL>
@@ -345,7 +366,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.9">5.9</A> <A HREF="#toc5.9">Changes in 0.94.3</A>
+<H2><A NAME="ss5.10">5.10</A> <A HREF="#toc5.10">Changes in 0.94.3</A>
 </H2>
 <P>
 <UL>
@@ -355,7 +376,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.10">5.10</A> <A HREF="#toc5.10">Changes in 0.94.2</A>
+<H2><A NAME="ss5.11">5.11</A> <A HREF="#toc5.11">Changes in 0.94.2</A>
 </H2>
 <P>
 <UL>
@@ -366,7 +387,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.11">5.11</A> <A HREF="#toc5.11">Changes in 0.94.1</A>
+<H2><A NAME="ss5.12">5.12</A> <A HREF="#toc5.12">Changes in 0.94.1</A>
 </H2>
 <P>
 <UL>
@@ -374,7 +395,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.12">5.12</A> <A HREF="#toc5.12">Changes in 0.94.0</A>
+<H2><A NAME="ss5.13">5.13</A> <A HREF="#toc5.13">Changes in 0.94.0</A>
 </H2>
 <P>
 <UL>
@@ -399,7 +420,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.13">5.13</A> <A HREF="#toc5.13">Changes in 0.93.2</A>
+<H2><A NAME="ss5.14">5.14</A> <A HREF="#toc5.14">Changes in 0.93.2</A>
 </H2>
 <P>
 <UL>
@@ -412,7 +433,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.14">5.14</A> <A HREF="#toc5.14">Changes in 0.93.1</A>
+<H2><A NAME="ss5.15">5.15</A> <A HREF="#toc5.15">Changes in 0.93.1</A>
 </H2>
 <P>
 <UL>
@@ -426,7 +447,7 @@ Alternatively, have a look at <B>Makefil
 </UL>
 </P>
 
-<H2><A NAME="ss5.15">5.15</A> <A HREF="#toc5.15">Changes in 0.93.0</A>
+<H2><A NAME="ss5.16">5.16</A> <A HREF="#toc5.16">Changes in 0.93.0</A>
 </H2>
 <P>
 <UL>
@@ -469,7 +490,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.16">5.16</A> <A HREF="#toc5.16">Changes in 0.92.1</A>
+<H2><A NAME="ss5.17">5.17</A> <A HREF="#toc5.17">Changes in 0.92.1</A>
 </H2>
 <P>
 <UL>
@@ -479,7 +500,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.17">5.17</A> <A HREF="#toc5.17">Changes in 0.92.0</A>
+<H2><A NAME="ss5.18">5.18</A> <A HREF="#toc5.18">Changes in 0.92.0</A>
 </H2>
 <P>
 <UL>
@@ -499,7 +520,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.18">5.18</A> <A HREF="#toc5.18">Changes in 0.91.0</A>
+<H2><A NAME="ss5.19">5.19</A> <A HREF="#toc5.19">Changes in 0.91.0</A>
 </H2>
 <H3>Bugfixes</H3>
 <P>
@@ -549,7 +570,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.19">5.19</A> <A HREF="#toc5.19">Changes in 0.90.1</A>
+<H2><A NAME="ss5.20">5.20</A> <A HREF="#toc5.20">Changes in 0.90.1</A>
 </H2>
 <H3>Bugfixes</H3>
 <P>
@@ -599,7 +620,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.20">5.20</A> <A HREF="#toc5.20">Changes in 0.90.0</A>
+<H2><A NAME="ss5.21">5.21</A> <A HREF="#toc5.21">Changes in 0.90.0</A>
 </H2>
 <P>
 <UL>
@@ -645,7 +666,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.21">5.21</A> <A HREF="#toc5.21">Changes in 0.85.9</A>
+<H2><A NAME="ss5.22">5.22</A> <A HREF="#toc5.22">Changes in 0.85.9</A>
 </H2>
 <P>
 <UL>
@@ -669,7 +690,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.22">5.22</A> <A HREF="#toc5.22">Changes in 0.85.8</A>
+<H2><A NAME="ss5.23">5.23</A> <A HREF="#toc5.23">Changes in 0.85.8</A>
 </H2>
 <P>
 <UL>
@@ -694,7 +715,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.23">5.23</A> <A HREF="#toc5.23">Changes in 0.85.7</A>
+<H2><A NAME="ss5.24">5.24</A> <A HREF="#toc5.24">Changes in 0.85.7</A>
 </H2>
 <P>
 <UL>
@@ -712,7 +733,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.24">5.24</A> <A HREF="#toc5.24">Changes in 0.85.6</A>
+<H2><A NAME="ss5.25">5.25</A> <A HREF="#toc5.25">Changes in 0.85.6</A>
 </H2>
 <P>
 <UL>
@@ -723,7 +744,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.25">5.25</A> <A HREF="#toc5.25">Changes in 0.85.5</A>
+<H2><A NAME="ss5.26">5.26</A> <A HREF="#toc5.26">Changes in 0.85.5</A>
 </H2>
 <P>
 <UL>
@@ -742,7 +763,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.26">5.26</A> <A HREF="#toc5.26">Changes in 0.85.4</A>
+<H2><A NAME="ss5.27">5.27</A> <A HREF="#toc5.27">Changes in 0.85.4</A>
 </H2>
 <P>
 <UL>
@@ -760,7 +781,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.27">5.27</A> <A HREF="#toc5.27">Changes in 0.85.3</A>
+<H2><A NAME="ss5.28">5.28</A> <A HREF="#toc5.28">Changes in 0.85.3</A>
 </H2>
 <P>
 <UL>
@@ -782,7 +803,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.28">5.28</A> <A HREF="#toc5.28">Changes in 0.85.2</A>
+<H2><A NAME="ss5.29">5.29</A> <A HREF="#toc5.29">Changes in 0.85.2</A>
 </H2>
 <P>
 <UL>
@@ -799,7 +820,7 @@ quakespasm (cl_alwaysrun 1, cl_forwardsp
 </UL>
 </P>
 
-<H2><A NAME="ss5.29">5.29</A> <A HREF="#toc5.29">Changes in 0.85.1</A>
+<H2><A NAME="ss5.30">5.30</A> <A HREF="#toc5.30">Changes in 0.85.1</A>
 </H2>
 <P>
 <UL>
diff -pruN 0.96.1+dfsg-1/Quakespasm.txt 0.96.2+dfsg-1/Quakespasm.txt
--- 0.96.1+dfsg-1/Quakespasm.txt	2023-09-24 14:03:10.000000000 +0000
+++ 0.96.2+dfsg-1/Quakespasm.txt	2024-06-10 02:20:02.000000000 +0000
@@ -3,7 +3,7 @@
   ______________________________________________________________________
 
 
-  Page last edited: September 2023.
+  Page last edited: June 2024.
 
 
   1. About
@@ -221,6 +221,39 @@
 
   5. Changes
 
+  Changes in 0.96.2:
+
+  -  Fix stack buffer overrun Mod_PolyForUnlitSurface: fixes crash when
+     loading lim_daviddg.bsp from Liminal Spaces Jam.
+
+  -  Fix potential buffer overflow in progs global string functions.
+
+  -  Fix potential buffer overflow in Mod_LoadAliasFrame()
+
+  -  Optimize BoxOnPlaneSide()
+
+  -  Reserve enough space in PF_makestatic() for worst case scenarios.
+
+  -  Improve handling of huge entities in SV_FindTouchedLeafs()
+
+  -  Warn about bad maps with only 1 or 2 edges per face (e.g.: mj4m?,
+     alk_dancing, ej3_bizz, rotj_entsoy...)
+
+  -  Apply FOV gun scaling for r_showtris
+
+  -  Sliders with visible values in options menu.
+
+  -  game command now refuses setting a non-existing game directory
+
+  -  Fix build in C23 mode.
+
+  -  Minor code cleanups. Updated third party code, e.g. SDL, music
+     codecs, etc.
+
+  -  Thanks to Andrei Drexler, Alexey Lysiuk, Diordany van Hemert, and
+     Jaime Moreira for patches.
+
+
   Changes in 0.96.1:
 
   -  Fix demo recording as client-only after connection to server (was
diff -pruN 0.96.1+dfsg-1/debian/changelog 0.96.2+dfsg-1/debian/changelog
--- 0.96.1+dfsg-1/debian/changelog	2023-10-21 16:06:50.000000000 +0000
+++ 0.96.2+dfsg-1/debian/changelog	2024-06-13 07:01:05.000000000 +0000
@@ -1,3 +1,10 @@
+quakespasm (0.96.2+dfsg-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Standards-Version 4.7.0, no change required.
+
+ -- Stephen Kitt <skitt@debian.org>  Thu, 13 Jun 2024 09:01:05 +0200
+
 quakespasm (0.96.1+dfsg-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 0.96.1+dfsg-1/debian/control 0.96.2+dfsg-1/debian/control
--- 0.96.1+dfsg-1/debian/control	2023-09-07 11:35:19.000000000 +0000
+++ 0.96.2+dfsg-1/debian/control	2024-06-13 06:58:56.000000000 +0000
@@ -13,7 +13,7 @@ Build-Depends: debhelper-compat (= 13),
                libsdl2-dev,
                libvorbis-dev
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/games-team/quakespasm
 Vcs-Git: https://salsa.debian.org/games-team/quakespasm.git
 Homepage: http://quakespasm.sourceforge.net/
diff -pruN 0.96.1+dfsg-1/debian/copyright 0.96.2+dfsg-1/debian/copyright
--- 0.96.1+dfsg-1/debian/copyright	2023-09-07 19:27:13.000000000 +0000
+++ 0.96.2+dfsg-1/debian/copyright	2024-06-13 06:59:18.000000000 +0000
@@ -11,6 +11,20 @@ Copyright: 1996-2005 Id Software, Inc.
            2010-2019 QuakeSpasm developers
 License: GPL-2+
 
+Files: Linux/net.sourceforge.quakespasm.Quakespasm.appdata.xml
+Copyright: none
+License: CC0-1.0
+ To the extent possible under law, the author(s) have dedicated all
+ copyright and related and neighboring rights to this software to the
+ public domain worldwide. This software is distributed without any warranty.
+ .
+ You should have received a copy of the CC0 Public Domain Dedication
+ along with this software. If not, see
+ <http://creativecommons.org/publicdomain/zero/1.0/>.
+ .
+ On Debian systems, the full text of the CC0 Public Domain Dedication
+ can be found in `/usr/share/common-licenses/CC0-1.0'.
+
 Files: Misc/qs_pak/mkpak.sh
 Copyright: 2014 Sander van Dijk
 License: ISC
@@ -64,7 +78,7 @@ License: ISC
 Files: debian/*
 Copyright: 2011-2013 David Banks
            2011-2013, 2016-2020 Simon McVittie
-           2012, 2015-2019, 2021-2023 Stephen Kitt
+           2012, 2015-2019, 2021-2024 Stephen Kitt
 License: GPL-2+
 
 License: GPL-2+
diff -pruN 0.96.1+dfsg-1/debian/quakespasm.install 0.96.2+dfsg-1/debian/quakespasm.install
--- 0.96.1+dfsg-1/debian/quakespasm.install	2023-09-07 11:35:19.000000000 +0000
+++ 0.96.2+dfsg-1/debian/quakespasm.install	2024-06-13 06:56:32.000000000 +0000
@@ -1,2 +1,4 @@
-Quake/quakespasm /usr/games
+Linux/*.appdata.xml /usr/share/metainfo
+Linux/*.desktop /usr/share/applications
 Misc/qs_pak/quakespasm.pak /usr/share/games/quake
+Quake/quakespasm /usr/games
